//KLasse für die Antriebsmotoren des Roboters

class Motor
{
  private:
    int stepperPin;
    int directionPin;


  public:
    void setup(int stepperPinPar, int directionPinPar) {
      stepperPin = stepperPinPar;
      directionPin = directionPinPar;

      pinMode(stepperPin, OUTPUT);
      pinMode(directionPin, OUTPUT);

      digitalWrite(stepperPin, LOW);
    }

//Funktion zum vorwärts fahren eines Motors
    void drivefwd(int milliSecDelay) {
      digitalWrite(directionPin, HIGH);

      digitalWrite(stepperPin, HIGH);
      delay(milliSecDelay);
      digitalWrite(stepperPin, LOW);
      delay(milliSecDelay);
    }

//Funktion zum rückwärts fahren eines Motors
    void drivebwd(int milliSecDelay) {
      digitalWrite(directionPin, LOW);

      digitalWrite(stepperPin, HIGH);
      delay(milliSecDelay);
      digitalWrite(stepperPin, LOW);
      delay(milliSecDelay);
    }
};
