//Klasse für die 5 Ultraschall-Sensoren

class Sensor
{
  private:
    int trigPin;
    int echoPin;


  public:
    void setup(int trigPinPar, int echoPinPar) {
      trigPin = trigPinPar;
      echoPin = echoPinPar;

      pinMode(trigPin, OUTPUT);
      pinMode(echoPin, INPUT);
    }

//Funktion, die den Abstand zu einem bestimmten Sensor zurück gibt
    long abstandMessen() {
      digitalWrite(trigPin, LOW);
      delayMicroseconds(2);

      digitalWrite(trigPin, HIGH);
      delayMicroseconds(10);
      digitalWrite(trigPin, LOW);

      long dauer = pulseIn(echoPin, HIGH);

      int abstand = dauer * 0.034 / 2;    //in cm umrechnen

      return abstand;
    }
};
