#include"MotorKlasse.h"
#include"SensorKlasse.h"
#include <SimpleList.h>

//Objekte vom Typ Motor werden erstellt
Motor rechterMotor;
Motor linkerMotor;

//Objekte vom Typ Sensor werden erstellt
Sensor sensorVorneUntenRechts;
Sensor sensorVorneUntenLinks;
Sensor sensorHintenUnten;
Sensor sensorVorne;
Sensor sensorHinten;

//Variablen für die verschiedenen "fahren"-Funktionen (s.u.)
int wait = 3;
int counter = 0;

//erstellt die Liste "weg"
SimpleList<char>* weg = new SimpleList<char>();
int theSize = weg->size();

void setup() {
  Serial.begin(9600);

//teilt Motoren und Sensoren Pins zu
  rechterMotor.setup(3, 4);
  linkerMotor.setup(5, 6);

  sensorVorneUntenRechts.setup(7, 8);
  sensorVorneUntenLinks.setup(A4, A5);
  sensorHintenUnten.setup(9, 10);
  sensorVorne.setup(A2, A3);
  sensorHinten.setup(11, 12);
}

void loop() {//was der Roboter am Ende tut (noch in der Testphase und noch nicht vollständig)
    int abstandVorneUntenRechts = sensorVorneUntenRechts.abstandMessen();
    int abstandVorneUntenLinks = sensorVorneUntenLinks.abstandMessen();
    /*int abstandHintenUnten = sensorHintenUnten.abstandMessen();
    int abstandVorne = sensorVorne.abstandMessen();
    int abstandHinten = sensorHinten.abstandMessen();*/


  
  /*if ((abstandVorneUntenRechts <= 10) && (abstandVorne > 6)) {
    drivefwd();
    } else {
    if ((abstandHintenUnten <= 10) && (abstandHinten > 8)) {
      for (int i = 0; i < 120; i++) {
        drivebwd();
      }
      for (int i = 0; i < 90; i++) {
        if ((abstandVorneUntenRechts <= 10) && (abstandVorne < 8) && (abstandHintenUnten <= 10) && (abstandHinten > 8)) {
          drivefwdl();
        }
      }
    } else {
      for (int i = 0; i < 15; i++) {
        drivefwd();
      }
      for (int i = 0; i < 90; i++) {
        if ((abstandVorneUntenRechts <= 10) && (abstandVorne < 8) && (abstandHintenUnten <= 10) && (abstandHinten > 8)) {
          drivefwdl();
        }
      }
    }
    }*/

  /*
    if ((abstandVorne > 10) && (abstandVorneUntenRechts < 10)) {
      drivefwd();
    } else if ((abstandVorne > 10) && (abstandVorneUntenRechts > 10)) {
      for (int i=0; i<150; i++){
        if(abstandHintenUnten < 10){
          drivebwd();
          drivefwdl();
          drivebwd();
        }
      }
    } /*else if ((abstandHinten > 10) && (abstandHintenUnten < 10)) {
      drivebwd();
    }*/




}

/*Serial.println(abstandVorne);
  Serial.println(abstandVorneUntenRechts);
  }*/

//Funktion zum vorwärtsfahren (beide Motoren fahren vorwärts), fügt der Liste ein Element hinzu
void drivefwd() {
  // Fahre vorwärts
  rechterMotor.drivefwd(wait);
  linkerMotor.drivefwd(wait);
  counter++;
  if (counter == 3) {
    rechterMotor.drivefwd(wait);
    rechterMotor.drivefwd(wait);
    counter = 0;
  }
  //return 'f';
 // n++;
 weg->add('f');
}

//Funktion zum rückwärtsfahren (beide Motoren fahren rückwärts), fügt der Liste ein Element hinzu
void drivebwd() {
  // Fahre rückwärts
  rechterMotor.drivebwd(wait);
  linkerMotor.drivebwd(wait);
  counter++;
  if (counter == 3) {   //der Roboter hat einen Linksdrang, deshalb können wir nicht beide Motoren gleich oft vorwärts fahren lassen, siehe auch bei drivefwd
    rechterMotor.drivebwd(wait);
    rechterMotor.drivebwd(wait);
    counter = 0;
  }
  //return 'b';
  //n++;
  weg->add('b');
}

/*void drivefwdl() {
  //fahre nach vorne rechts
  rechterMotor.drivefwd(wait);
  linkerMotor.drivebwd(wait);
  rechterMotor.drivefwd(wait);
  }

  void drivefwdr() {
  //fahre nach vorne links
  rechterMotor.drivebwd(wait);
  linkerMotor.drivefwd(wait);
  }*/

//Funktion zum nach rechts drehen (rechter Motor rückwärts, linker vorwärts), fügt der Liste ein Element hinzu
void drivebwdl() {
  //fahre nach hinten links
  rechterMotor.drivebwd(wait);
  linkerMotor.drivefwd(wait);
  rechterMotor.drivebwd(wait);

  //return 'l';
  //n++;
  weg->add('l');
}

//Funktion zum nach links drehen (rechter Motor vorwärts, linker rückwärts), fügt der Liste ein Element hinzu
void drivebwdr() {
  //fahre nach hinten rechts
  linkerMotor.drivebwd(wait);
  rechterMotor.drivefwd(wait);

  //return 'r';
  //n++;
  weg->add('r');
}
